export class SimpleCarSplitter {
    /**
     * @param {Blob} blob
     * @param {number} targetSize
     */
    static fromBlob(blob: Blob, targetSize: number): Promise<SimpleCarSplitter>;
    /**
     * @param {AsyncIterable<Uint8Array>} iterable
     * @param {number} targetSize
     */
    static fromIterable(iterable: AsyncIterable<Uint8Array>, targetSize: number): Promise<SimpleCarSplitter>;
    /**
     * @param {CarReader} reader
     * @param {number} targetSize
     */
    constructor(reader: CarReader, targetSize: number);
    _reader: CarReader;
    _targetSize: number;
    cars(): AsyncGenerator<AsyncIterable<Uint8Array>, void, unknown>;
}
import { CarReader } from "@ipld/car";
//# sourceMappingURL=splitter.d.ts.map